<?php
namespace Adwise\BundleUrl\Helper;

class Data extends \Magento\Framework\App\Helper\AbstractHelper
{ 
    protected $bundletype;
    protected $_productFactory;

    public function __construct(
        \Magento\Framework\App\Helper\Context $context,
        \Magento\Bundle\Model\Product\Type $bundletype,
        \Magento\Catalog\Model\ProductFactory $_productFactory)
    {
        $this->bundletype = $bundletype;
        $this->_productFactory = $_productFactory;
        parent::__construct($context);
    }

    public function getBundleParentProduct($id) {
        $bundleProductsId = $this->bundletype->getParentIdsByChild($id);
        $selections = array();
        foreach ($bundleProductsId as $key => $bundleId) {
            $option_fromBundle = $this->_productFactory->create()->load($bundleId);
            if($option_fromBundle->isAvailable()) {
                $selectionOption = $option_fromBundle->getTypeInstance(true)->getSelectionsCollection($option_fromBundle->getTypeInstance(true)->getOptionsIds($option_fromBundle),$option_fromBundle);
                foreach ($selectionOption as $option) {
                    $selections[$key]['url'] = $option_fromBundle->getProductUrl();
                    $selections[$key]['qty'] = (int)$option->getSelectionQty();
                    $selections[$key]['url_child'] = $option->getProductUrl();
                }
            }
        }
        return $selections;
    }
	
}