<?php

namespace Adwise\SalableQtyExport\Plugin;

use Magento\Catalog\Model\Export\Product as ProductExport;
use Magento\Framework\App\ResourceConnection;
use Magento\InventorySalesApi\Api\GetProductSalableQtyInterface;

class ExportAddSalableQty
{
    protected $getProductSalableQty;

    public function __construct(
        GetProductSalableQtyInterface $getProductSalableQty
    ) {
        $this->getProductSalableQty = $getProductSalableQty;
    }

    public function afterExportItem(
        ProductExport $subject,
        array $result,
        $item
    ) {
        $productId = $item->getId();
        $websiteId = 1; // Cambia según tu configuración

        try {
            $salableQty = $this->getProductSalableQty->execute($productId, $websiteId);
        } catch (\Exception $e) {
            $salableQty = 0;
        }

        // Agrega el campo 'salable_qty' al resultado de la exportación
        $result['salable_qty'] = $salableQty;

        return $result;
    }
}
