<?php
namespace Adwise\StockQtyIncrements\Plugin;

use Magento\Catalog\Api\ProductRepositoryInterface;
use Magento\Catalog\Model\Product;
use Magento\Quote\Model\Quote\Item;

class DefaultItem
{
    protected $_productloader;

    public function __construct(
        \Magento\Catalog\Model\ProductFactory $_productloader
    )
    {
        $this->_productloader = $_productloader;
    }

    public function aroundGetItemData($subject, \Closure $proceed, Item $item)
    {
        $data = $proceed($item);

        /** @var Product $product */
        $product = $this->_productloader->create()->load($item->getProduct()->getId());

        $stockItem = $product->getExtensionAttributes()->getStockItem();
        $qtyIncrement = $stockItem->getQtyIncrements() ? $stockItem->getQtyIncrements() : 1;

        $moreOfOne = (intVal($qtyIncrement) > 1) ? 'show' : '';

        $atts = [
            'product_marca' => $product->getMarca(),
            'qty_increments' => $qtyIncrement,
            'qtyincrements_more_of_one' => $moreOfOne
        ];

        return array_merge($data, $atts);
    }
}