<?php

namespace Ymina\Balanceo\Block\Order;

class Totals extends \Magento\Framework\View\Element\AbstractBlock
{
    private $helper;

    private $quoteFactory;

    public function __construct(
        \Magento\Framework\View\Element\Context $context,
        \Ymina\Balanceo\Helper\Data             $helper,
        \Magento\Quote\Model\QuoteFactory       $quoteFactory,
        array                                   $data = [])
    {
        $this->helper = $helper;
        $this->quoteFactory = $quoteFactory;
        parent::__construct($context, $data);
    }

    public function initTotals()
    {
        $orderTotalsBlock = $this->getParentBlock();
        $order = $orderTotalsBlock->getOrder();
        $quote = $this->quoteFactory->create()->load($order->getQuoteId());
        if ($this->helper->isValid($quote, $order->getAllItems())) {
            $orderTotalsBlock->addTotal(new \Magento\Framework\DataObject([
                'code' => 'balanceo',
                'label' => __($this->helper->getTaxBalanseoTitle()),
                'value' => $this->helper->getTaxBalanseoAmount(),
                'base_value' => $this->helper->getTaxBalanseoAmount(),
            ]), 'subtotal');
        }
    }
}