define([
        'Magento_Checkout/js/view/summary/abstract-total',
        'Magento_Checkout/js/model/quote',
        'Magento_Catalog/js/price-utils',
        'Magento_Checkout/js/model/totals'
    ], function (Component, quote, priceUtils, totals) {
        "use strict";
        return Component.extend({
            defaults: {
                isFullTaxSummaryDisplayed: window.checkoutConfig.isFullTaxSummaryDisplayed || false,
                template: 'Ymina_Balanceo/checkout/summary/balanceo'
            },
            totals: quote.getTotals(),
            isTaxDisplayedInGrandTotal: window.checkoutConfig.includeTaxInGrandTotal || false,

            isDisplayed: function () {
                console.log( this.getPureValue().balanceoTotal)
                return this.isFullMode() && this.getPureValue().balanceoTotal != null;
            },

            getValue: function () {
                var price = 0;
                if (this.totals()) {
                    price = totals.getSegment('balanceo').value;
                }
                return this.getFormattedPrice(price);
            },

            /**
             *
             * @returns {{amount: number, taxTotal: null}}
             */
            getPureValue: function () {
                var amount = 0,
                    balanceoTotal = null;

                if (this.totals()) {
                    balanceoTotal = totals.getSegment('balanceo');

                    if (balanceoTotal) {
                        amount = balanceoTotal.value;
                    }
                }

                return {amount, balanceoTotal};
            },
        });
    }
);