<?php

namespace Ymina\CancelPending\Helper;

use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Store\Model\ScopeInterface;

/**
 * Helper Data
 */
class Data extends AbstractHelper
{

	const XML_PATH_STATUS  = 'status/',
          CAMBIO_ESTADO    = 'cambioEstado/',
          ENABLE           = 'enable',
          MINUTES          = 'minutes',
          PRIMARY_STATUS   = 'primaryStatus',
          SECONDARY_STATUS = 'secondaryStatus',
		  BATCH 		   = 'batch',
          FROM_DATE_TEXT   = 'from_date_text';

    /**
     *  Get config value
     * @param  string  $field
     * @param  integer $storeId
     * @return string
     */
	public function getConfigValue($field, $storeId = null)
	{
		return $this->scopeConfig->getValue(
			$field, ScopeInterface::SCOPE_STORE,
            $storeId
		);
	}

    /**
     *  Get general config
     * @param  string $code
     * @param  integer $storeId
     * @return string
     */
	public function getGeneralConfig($code, $storeId = null)
	{
        $generalConfig = $this->getConfigValue(
            self::XML_PATH_STATUS.self::CAMBIO_ESTADO.$code,
            $storeId
        );

		return $generalConfig;
	}

}
