<?php

namespace Ymina\Checkout\Controller\Index;


class typeDelivery extends \Magento\Framework\App\Action\Action
{

    protected $resultPageFactory;
    protected $jsonHelper;
    private \Magento\Framework\App\Action\Context $context;


    /**
     * @var \Magento\Framework\App\Request\DataPersistor
     */
    private $_dataPersistor;

    private $logger;
    /**
     * Constructor
     *
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Magento\Framework\Json\Helper\Data $jsonHelper
     */
    public function __construct(
        \Magento\Framework\App\Action\Context        $context,
        \Magento\Framework\View\Result\PageFactory   $resultPageFactory,
        \Magento\Framework\Json\Helper\Data          $jsonHelper,
        \Psr\Log\LoggerInterface                     $logger,
        \Magento\Framework\App\Request\DataPersistor $dataPersistor
    )
    {
        $this->resultPageFactory = $resultPageFactory;
        $this->jsonHelper = $jsonHelper;
        $this->logger = $logger;
        $this->_dataPersistor = $dataPersistor;
        parent::__construct($context);
    }

    /**
     * Execute view action
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function execute()
    {
        try {

            if (!$this->_request->getParam('method')) {
                return $this->jsonResponse('required typeDelivery key');
            }

            $this->_dataPersistor->set('typeDelivery', $this->_request->getParam('method'));

            return $this->jsonResponse("ok");
        } catch (\Magento\Framework\Exception\LocalizedException $e) {
            return $this->jsonResponse($e->getMessage());
        } catch (\Exception $e) {
            $this->logger->critical($e);
            return $this->jsonResponse($e->getMessage());
        }
    }

    /**
     * Create json response
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function jsonResponse($response = '')
    {
        return $this->getResponse()->representJson(
            $this->jsonHelper->jsonEncode($response)
        );
    }
}
