<?php

namespace Ymina\Checkout\Helper;

use Magento\Checkout\Model\Session;
use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Framework\App\Helper\Context;
use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\Exception\NoSuchEntityException as NoSuchEntityExceptionAlias;
use Magento\Quote\Model\Quote\Address\RateRequest;

class Data extends AbstractHelper
{
    private Context $context;
    private Session $checkoutSession;

    public function __construct(Context $context, Session $checkoutSession)
    {
        parent::__construct($context);
        $this->context = $context;
        $this->checkoutSession = $checkoutSession;
    }

    /**
     * @throws NoSuchEntityExceptionAlias
     * @throws LocalizedException
     */
    public function isVirtual(RateRequest $request): bool
    {
        $items = $request->getAllItems();
        $result = false;
        foreach ($items as $item) {
            if ($item->getProductType() !== "amgiftcard") {
                return false;
            } else {
                $result = true;
            }
        }
        return $result;
    }
}
