<?php

namespace Ymina\Checkout\Plugin;

use Magento\Framework\Api\DataObjectHelper;
use Ymina\Checkout\Model\CustomerAddressCustomAttributesProcessor;


class DataObjectHelperPlugin
{

    private $_logger;

    private $_dataPersistor;

    public function __construct(
        \Psr\Log\LoggerInterface                     $logger,
        \Magento\Framework\App\Request\DataPersistor $dataPersistor
    )
    {
        $this->_logger = $logger;
        $this->_dataPersistor = $dataPersistor;

    }

    public function beforePopulateWithArray(
        $helper,
        $dataObject,
        array $data,
        $interfaceName
    )
    {
        if ($interfaceName === \Magento\Customer\Api\Data\AddressInterface::class) {
            if (!array_key_exists('rut', $data) && key_exists('email', $data)) {
                $quoteAddress = $this->_dataPersistor->get('quoteAddress');
                $address = json_decode($quoteAddress, true);
                if (array_key_exists('rut', $address)) {
                    $data['rut'] = $address['rut'];
                    $this->_dataPersistor->clear('quoteAddress');
                }
            }
        }

        return array($dataObject, $data, $interfaceName);
    }
}