<?php

namespace Ymina\Checkout\Plugin\Frontend\Magento\Checkout\Block\Checkout;

use Psr\Log\LoggerInterface;

class AttributeMerger
{
    protected $_logger;
    public function __construct(LoggerInterface $logger)
    {
        $this->_logger = $logger;
    }

    public function afterMerge(
        \Magento\Checkout\Block\Checkout\AttributeMerger $subject,
                                                         $result,
                                                         $elements,
                                                         $providerName,
                                                         $dataScopePrefix,
                                                         $fields = []
    )
    {
        if (array_key_exists('street', $result)) {

            if (!array_key_exists('children', $result['street'])) return $result;

            $result['street']['sortOrder'] = 45;

            $a = [
                [
                    'placeholder' => __('Dirección'),
                ],
                [
                    'placeholder' => __('Número'),
                    'required-entry' => true
                ],
                [
                    'placeholder' => __('Dpto./Ofic./Casa')
                ]
            ];

            for ($i = 0; $i < count($result['street']['children']); $i++) {
                $result['street']['children'][$i]['config']['placeholder'] = $a[$i]['placeholder'];
                if (array_key_exists('required-entry', $a[$i])) {
                    $result['street']['children'][$i]['validation']['required-entry'] = $a[$i]['required-entry'];
                }
            }
        }
        return $result;
    }
}