<?php

namespace Ymina\Checkout\Plugin\Frontend\Magento\Tax\Block\Item\Price;

use Magento\Framework\Pricing\PriceCurrencyInterface;
use Magento\Framework\View\Element\Template\Context;
use Magento\Quote\Model\Quote\Item\AbstractItem as QuoteItem;
use Magento\Sales\Model\Order\Item as OrderItem;
use Magento\Tax\Helper\Data as TaxHelper;

class Renderer extends \Magento\Tax\Block\Item\Price\Renderer
{
    public function __construct(Context $context, TaxHelper $taxHelper, PriceCurrencyInterface $priceCurrency, array $data = [])
    {
        parent::__construct($context, $taxHelper, $priceCurrency, $data);
    }


    public function afterFormatPrice(
        \Magento\Tax\Block\Item\Price\Renderer $subject,
                                               $result,
                                               $price
    )
    {
        $item = $subject->getItem();
        if ($item instanceof QuoteItem) {
            return $this->priceCurrency->format(
                $price,
                true,
                0,
                $item->getStore()
            );
        } elseif ($item instanceof OrderItem) {
            return $item->getOrder()->formatPrice($price);
        } else {
            return $item->getOrderItem()->getOrder()->formatPrice($price);
        }
    }
}