<?php

namespace Ymina\Checkout\Plugin\Magento\Quote\Model;


class ShippingAddressManagement
{

    /**
     * @var \Psr\Log\LoggerInterface
     */
    protected $_logger;


    /**
     * @var \Magento\Framework\App\Request\DataPersistor
     */
    protected $_dataPersistor;


    /**
     * @param \Psr\Log\LoggerInterface $logger
     * @param \Magento\Framework\App\Request\DataPersistor $dataPersistor
     */
    public function __construct(
        \Psr\Log\LoggerInterface                     $logger,
        \Magento\Framework\App\Request\DataPersistor $dataPersistor
    )
    {
        $this->_logger = $logger;
        $this->_dataPersistor = $dataPersistor;
    }


    /**
     * @param \Magento\Quote\Model\ShippingAddressManagement $subject
     * @param $cartId
     * @param $address
     * @return array
     */
    public function beforeAssign(
        \Magento\Quote\Model\ShippingAddressManagement $subject,
                                                       $cartId,
                                                       $address
    )
    {
        $extAttributes = $address->getExtensionAttributes();
        if (!empty($extAttributes)) {
            try {
                $address->setRut($extAttributes->getRut());
                if ($address->getSaveInAddressBook()) {
                    $this->_dataPersistor->set("quoteAddress", json_encode($address->getData()));
                }
            } catch (\Exception $e) {
                $this->_logger->critical($e->getMessage());
            }
        }
        return [$cartId, $address];
    }
}