<?php

namespace Ymina\Checkout\Rewrite\Magento\Checkout\CustomerData;

use Magento\Catalog\Model\Product\Configuration\Item\ItemResolverInterface;
use Magento\Framework\Pricing\PriceCurrencyInterface;
use Psr\Log\LoggerInterface;

class DefaultItem extends \Magento\Checkout\CustomerData\DefaultItem
{
    /**
     * @var PriceCurrencyInterface
     */
    private $priceCurrency;

    private $logger;

    /**
     * @param \Magento\Catalog\Helper\Image $imageHelper
     * @param \Magento\Msrp\Helper\Data $msrpHelper
     * @param \Magento\Framework\UrlInterface $urlBuilder
     * @param \Magento\Catalog\Helper\Product\ConfigurationPool $configurationPool
     * @param \Magento\Checkout\Helper\Data $checkoutHelper
     * @param PriceCurrencyInterface $priceCurrency
     * @param LoggerInterface $logger
     * @param \Magento\Framework\Escaper|null $escaper
     * @param ItemResolverInterface|null $itemResolver
     */
    public function __construct(\Magento\Catalog\Helper\Image                     $imageHelper,
                                \Magento\Msrp\Helper\Data                         $msrpHelper,
                                \Magento\Framework\UrlInterface                   $urlBuilder,
                                \Magento\Catalog\Helper\Product\ConfigurationPool $configurationPool,
                                \Magento\Checkout\Helper\Data                     $checkoutHelper,
                                PriceCurrencyInterface                            $priceCurrency,
                                LoggerInterface $logger,
                                \Magento\Framework\Escaper                        $escaper = null,
                                ItemResolverInterface                             $itemResolver = null)
    {
        $this->priceCurrency = $priceCurrency;
        $this->logger = $logger;
        parent::__construct($imageHelper, $msrpHelper, $urlBuilder, $configurationPool, $checkoutHelper, $escaper, $itemResolver);
    }


    protected function doGetItemData()
    {
        $data = parent::doGetItemData(); // TODO: Change the autogenerated stub
        $data['product_price'] = $this->priceCurrency->format($this->item->getCalculationPrice(), true, 0);
        $this->logger->info($data['product_price']);
        return $data;
    }

}