define([
    'jquery',
    'ko',
    'mage/validation',
], function ($, ko) {
    return {
        _matchMedia: '(max-width: 768px)',

        /**
         *
         * @returns {boolean}
         */
        isMobile: function () {
            let mediaQuery = window.matchMedia(this._matchMedia);
            return mediaQuery.matches;
        },

        limitAddress: ko.observable(3),

        /**
         *
         * @param target
         */
        validated: function (target) {
            const $input = $(target);
            const $parent = $input.parent();
            $parent.removeClass('_validated');
            const invalid = $input.attr('aria-invalid');
            if (invalid !== 'true' && $input.val() !== '') {
                $parent.addClass('_validated');
            }
        }
    }
})