define([
    'jquery',
    'mage/url',
    'mage/translate'
], function ($, $url) {
    "use strict";

    $.widget('mage.addressEdit', {

        _create: function () {
            this._bind();
            if (this.options.defaultRegion.length && this.options.defaultRegion !== "0") {
                this._sendAjax({
                    regionId: this.options.defaultRegion,
                }, $(this.element).find('#city'), this.options.defaultCity)
            }
        },

        _bind: function () {
            let self = this;
            this.element.find('#region_id').change(function () {
                self._sendAjax({
                    regionId: $(this).val(),
                }, $('#city'));
            });
        },

        _sendAjax: function (data, element, selected = null) {
            $.ajax({
                url: $url.build("comuna"),
                data: data,
                showLoader: true,
                success: function (res) {
                    try {
                        console.log(data, res);
                        element.empty();
                        element.append(`<option value="">${ $.mage.__("Please select an option")}</option>`);
                        if (typeof res === "object" && 'options' in res && res.options.length) {
                            res.options.forEach(function (item) {
                                if (selected === item.value) {
                                    element.append(`<option selected="selected" value=${item.value}>${item.label}</option>`);
                                }else {
                                    element.append(`<option value=${item.value}>${item.label}</option>`);
                                }
                            });
                        }

                    } catch (e) {
                        console.log(e)
                    }
                }
            })
        }
    })

    return $.mage.addressEdit;
})