define([
    'underscore',
    'uiRegistry',
    'Magento_Ui/js/form/element/select',
    'Magento_Checkout/js/model/default-post-code-resolver',
    'Ymina_Checkout/js/model/shipping-type',
    'Magento_Checkout/js/model/shipping-rate-processor/new-address',
    'Magento_Checkout/js/model/quote',
], function (_, registry, Select, defaultPostCodeResolver, sippingType, newAddress, quote) {
    'use strict';
    let mixin = {
        defaults: {
            skipValidation: false,
            imports: {
                countryOptions: '${ $.parentName }.country_id:indexedOptions',
                update: '${ $.parentName }.country_id:value'
            }
        },
        initialize: function () {
            this._super();
            let self = this;

            if (this.initialOptions && this.initialOptions.length) {
                let options = this.initialOptions;
                options.sort((a, b) => {
                    if (a.label < b.label) {
                        return -1;
                    }
                    if (a.label > b.label) {
                        return 1;
                    }
                    return 0;
                });
                let itemToRemove = "";
                let index = options.findIndex(obj => obj.value === itemToRemove && obj.title === itemToRemove);
                if (index > -1) {
                    options.splice(index, 1);
                }

                this.options(options)
            }

            sippingType.type.subscribe(function (value) {
                if (value === 'pickupInStore') {
                    // storepickout
                    const regionsCurries = checkoutConfig.carrier.storepickup;
                    const regiosAllow = regionsCurries.getAvailableRegions;
                    const regions = regiosAllow.map(obj => {
                        return {
                            ...obj,
                            title: obj.label,
                            country_id: 'CL'
                        };
                    });
                    self.setOptions(regions)
                } else {
                    self.setOptions(self.initialOptions);
                }
            })

            return this;
        },

        hasChanged: function () {
            if (this.value) {
                newAddress.getRates(quote.shippingAddress())
            }
        }
    }
    return function (target) {
        return target.extend(mixin);
    };
})
