define([
    'jquery',
    'underscore',
    'uiRegistry',
    'Magento_Ui/js/form/element/select',
    'mage/translate',
    'mage/url',
    'Ymina_Checkout/js/model/shipping-type',
    'Magento_Checkout/js/model/shipping-rate-processor/new-address',
    'Magento_Checkout/js/model/quote',
], function ($, _, registry, Select, $t, $url, sippingType, newAddress, quote) {

    return Select.extend({
        defaults: {
            skipValidation: false,
            imports: {
                update: '${ $.parentName }.city:value',
                postcode: '${ $.parentName }.postcode'
            },
            options: [{title: $t("Distrito*"), value: "", label: $t("Distrito*")}],
            visible: false
        },

        /**
         * {@inheritdoc}
         */
        initialize: function () {
            this._super();
            //this.hideRegion(option);
            return this;
        },

        /**
         * On region update we check for city
         *
         * @param {string} city
         */
        update: function (city) {
            self = this;

            let url = $url.build("province_district/ajax/index");
            const data = {
                city: city,
                action: 'district'
            }

            //Logica para rito en tienda pendiente

            if (typeof city === "undefined") return;

            $.ajax({
                url: url,
                data: data,
                showLoader: true,
                success: function (data) {
                    try {
                        console.log(data);
                        self.options(data);
                    } catch (e) {
                        console.log(e)
                    }

                }
            })
        },

        hasChanged: function () {
            if (this.value()) {
                quote.shippingAddress().countryId = "PE";
                quote.shippingAddress().postcode = this.value();
                console.log(quote.shippingAddress())
                newAddress.getRates(quote.shippingAddress())
            }
        }
    })
})
