define([
    'underscore',
    'Magento_Ui/js/form/element/abstract',
    'Ymina_Checkout/js/rut-map',
], function (_, Abstract, rut) {
    "use strict"

    var self;

    return Abstract.extend({

        defaults: {
            id: 'rut',
            elementTmpl: 'ui/form/element/input'
        },

        initialize: function () {
            _.bindAll(this, 'reset');
            this._super()
            self = this;

            this.value.subscribe(function (newValue) {
                let value = rut.resetRut(newValue);
                self.value(rut.formatRut(value, 2))
            })

            return this;
        },

    })
})