define([
    'jquery',
    'underscore',
    'Magento_Ui/js/form/element/abstract',
    'Ymina_Checkout/js/rut-map',
    'Ymina_Checkout/js/model/document-type',
    'Magento_Checkout/js/model/quote',
], function ($, _, Abstract, rut, documentType, quote) {
    "use strict"

    var self;

    return Abstract.extend({

        defaults: {
            id: 'rut',
        },

        initialize: function () {
            this._super()
            self = this;
            if (quote.shippingAddress() && quote.shippingAddress().fax === 'rut') {
                documentType.type('rut')
            }

            documentType.type.subscribe(function (newValue) {
                self.validation['validate-rut'] = newValue === 'rut'
                let input = $('[name="vat_id"]');
                if (input.length) {
                    input.focus()
                    input.val('')
                    input.trigger('change')
                }
            })

            this.value.subscribe(function (newValue) {
                if (documentType.type() === 'rut') {
                    let value = rut.resetRut(newValue);
                    self.value(rut.formatRut(value.replace(' ', ''), 2))
                }
            })

            return this;
        },
    })
})