define([
    'Magento_Checkout/js/model/quote',
    'Magento_Catalog/js/price-utils'
], function (quote, priceUtils) {
    'use strict';

    let mixin = {

        /**
         *
         * @param itemId
         * @returns {{normal_price, special_price}}
         */
        getPrices: function (itemId) {
            let quoteItem = quote.getItems().find(function (item) {
                return item.item_id == itemId;
            })

            if (typeof quoteItem === "undefined") return;

            if (typeof quoteItem.product.price === "undefined" || parseFloat(quoteItem.product.price) < 1) return;

            if (this.getFormattedPrice(quoteItem.product.price) === this.getFormattedPrice(quoteItem.price)) return;

            return {
                normal_price: this.getFormattedPrice(quoteItem.price * quoteItem.qty),
                special_price: this.getFormattedPrice(quoteItem.product.price * quoteItem.qty)
            }
        },

        /**
         *
         * @param price
         * @returns {*}
         */
        getFormattedPrice: function (price) {
            return priceUtils.formatPriceLocale(price, quote.getPriceFormat());
        },
    }

    return function (target) {
        return target.extend(mixin);
    };

})
