define([
    'Magento_Checkout/js/model/quote',
], function (quote) {

    let mixin = {

        initialize: function () {
            this._super();

            return this;
        },

        getShippingMethodTitle: function () {
            let result = this._super(),
                shippingMethod = quote.shippingMethod();

            if (this.isCalculated()) {
                this.totals()['shipping_amount'] = shippingMethod['amount'];
            }


            return result;

        },

        /**
         * @return {*}
         */
        getValue: function () {
            var price;

            if (!this.isCalculated()) {
                return this.notCalculatedMessage;
            }
            price = this.totals()['shipping_amount'];

            return this.getFormattedPrice(price);
        },
    }

    return function (target) {
        return target.extend(mixin)
    }
})