<?php

namespace Ymina\CustomSearch\Model;


use Magento\Framework\App\ResourceConnection;
use Monolog\Handler\IFTTTHandler;

class CustomSearchIndex
{
    const FIELD_ALLOW = ["ancho_neumatico", "perfil_neumatico", "aro", "apernadura", "tipo_de_vehiculo"];
    private ResourceConnection $connection;

    public function __construct(
        ResourceConnection $connection
    )
    {
        $this->connection = $connection;
    }

    public function searchByParams($params)
    {
        // Construye la consulta SQL

        $select = $this->connection->getConnection()->select()->from(['csi' => 'ymina_custom_search_index']);

        // Aplica los filtros basados en los parámetros
        foreach ($params as $key => $value) {
            if (!in_array($key, self::FIELD_ALLOW))
                continue;
            $select->where("csi.$key = ?", $value);
        }
        $connection = $this->connection->getConnection();
        return $connection->fetchAll($select);
    }

    public function findAttributeValue($value, $column)
    {
        $select = $this->connection->getConnection()->select()->from(['csi' => 'ymina_custom_search_index']);
        $select->where("csi.$column = ?", $value);
        return $this->connection->getConnection()->fetchRow($select);
    }
}
