define([
        'Magento_Checkout/js/view/summary/abstract-total',
        'Magento_Checkout/js/model/quote',
        'Magento_Catalog/js/price-utils',
        'Magento_Checkout/js/model/totals'
    ], function (Component, quote, priceUtils, totals) {
        "use strict";
        return Component.extend({
            defaults: {
                isFullTaxSummaryDisplayed: window.checkoutConfig.isFullTaxSummaryDisplayed || false,
                template: 'Ymina_ECOTax/checkout/summary/total'
            },
            totals: quote.getTotals(),
            isTaxDisplayedInGrandTotal: window.checkoutConfig.includeTaxInGrandTotal || false,

            isDisplayed: function () {
                return this.isFullMode() && this.getPureValue().amount !== null;
            },

            getValue: function () {
                var price = 0;
                if (this.totals()) {
                    price = totals.getSegment('taxEco').value;
                }
                return this.getFormattedPrice(price);
            },

            /**
             *
             * @returns {{amount: number, taxTotal: null}}
             */
            getPureValue: function () {
                var amount = 0,
                    taxTotal = null;

                if (this.totals()) {
                    taxTotal = totals.getSegment('taxEco');

                    if (taxTotal) {
                        amount = taxTotal.value;
                    }
                }

                return {amount, taxTotal};
            },
        });
    }
);