<?php
/**
 * Copyright ©  All rights reserved.
 * See COPYING.txt for license details.
 */
declare(strict_types=1);

namespace Ymina\HomeDelivery\Model;

use Magento\Framework\Model\AbstractModel;
use Ymina\HomeDelivery\Api\Data\FeeInterface;

class Fee extends AbstractModel implements FeeInterface
{

    /**
     * @inheritDoc
     */
    public function _construct()
    {
        $this->_init(\Ymina\HomeDelivery\Model\ResourceModel\Fee::class);
    }

    /**
     * @inheritDoc
     */
    public function getFeeId()
    {
        return $this->getData(self::FEE_ID);
    }

    /**
     * @inheritDoc
     */
    public function setFeeId($feeId)
    {
        return $this->setData(self::FEE_ID, $feeId);
    }

    /**
     * @inheritDoc
     */
    public function getCommune()
    {
        return $this->getData(self::COMMUNE);
    }

    /**
     * @inheritDoc
     */
    public function setCommune($commune)
    {
        return $this->setData(self::COMMUNE, $commune);
    }

    /**
     * @inheritDoc
     */
    public function getCost()
    {
        return $this->getData(self::COST);
    }

    /**
     * @inheritDoc
     */
    public function setCost($cost)
    {
        return $this->setData(self::COST, $cost);
    }
}

