/**
 * Billing address view mixin for restrict billing address copy from shipping
 */
define([
    'jquery',
    'Amasty_StorePickupWithLocator/js/model/pickup',
    'Amasty_StorePickupWithLocator/js/model/pickup/pickup-data-resolver',
    'Magento_Checkout/js/model/quote',
    'Magento_Checkout/js/model/checkout-data-resolver',
    'Magento_Checkout/js/action/select-billing-address',
    'Magento_Checkout/js/checkout-data',
], function ($, pickup, pickupDataResolver, quote, checkoutDataResolver, selectBillingAddress, checkoutData) {
    'use strict';

    return function (billingAddress) {
        var lastSelectedBillingAddress = null;
        var isEditAddressCalled = false;


        return billingAddress.extend({
            initObservable: function () {
                this._super();
                this.isAddressDetailsVisible(true)
                this.isAddressSameAsShipping(true)
                quote.billingAddress.subscribe(function (address) {
                    if (address != null && typeof address.getType == "function" && address?.getType() === 'store-pickup-address' && checkoutData.getSelectedBillingAddress()) {
                        const newAddress = checkoutData.getSelectedBillingAddress();
                        console.log(newAddress)
                        const address_data = window.localStorage.getItem('address_data');
                        if (address_data && JSON.parse(address_data)) {
                            if (quote.shippingMethod() && quote.shippingMethod().carrier_code === "amstorepickup") {
                                checkoutData.getSelectedBillingAddress().city = JSON.parse(address_data).city;
                            }
                        }
                        selectBillingAddress(newAddress)
                        $('.billing-address-same-as-shipping-block').hide();
                    }
                })
                return this;
            },

            /**
             * @return {Boolean}
             */
            useShippingAddress: function () {
                console.log(checkoutData.getSelectedBillingAddress())
                if (this.isAddressSameAsShipping()) {
                    selectBillingAddress(checkoutData.getSelectedBillingAddress());
                    this.updateAddresses(true);
                    this.isAddressDetailsVisible(true);
                } else {
                    lastSelectedBillingAddress = quote.billingAddress();
                    quote.billingAddress(null);
                    this.isAddressDetailsVisible(false);
                }
                //checkoutData.setSelectedBillingAddress(null);

                return true;
            },
        });
    };
});
