define([
    'jquery',
    'ko',
    'Magento_Checkout/js/model/quote',
    'Magento_Checkout/js/model/step-navigator',
    'Amasty_StorePickupWithLocator/js/model/pickup',
    'Magento_Checkout/js/action/select-shipping-method',
    'Amasty_StorePickupWithLocator/js/model/pickup/pickup-data-resolver',
    'Amasty_StorePickupWithLocator/js/model/shipping-address-service',
    'Magento_Checkout/js/model/shipping-service',
    'Magento_Checkout/js/checkout-data'
], function ($, ko, quote, stepNavigator, pickup, selectShippingMethodAction, pickupDataResolver, addressService, shippingService, checkoutData) {
    let mixin = {
        initialize: function () {
            this._super();

            stepNavigator.steps.subscribe(function () {
                if (window.location.hash === "#shipping_methods") {
                    window.localStorage.setItem('removeShippingMethod', true)
                } else if (window.location.hash === "#payment") {
                    window.localStorage.setItem('removeShippingMethod', false)
                }

                if (window.location.hash === "#shipping" && Boolean(window.localStorage.getItem('removeShippingMethod'))) {
                    if (pickupDataResolver.storeId()) {
                        pickupDataResolver.removeStore(pickupDataResolver.storeId())
                    }

                    checkoutData.setSelectedShippingRate(null);
                    quote.shippingMethod(null)
                }
            })

            return this;
        }
    }

    return function (target) {
        return target.extend(mixin)
    }

})