<?php

namespace Ymina\WarehouseStock\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Ymina\WarehouseStock\Model\ManagerIntegration;
use Ymina\WarehouseStock\Model\WarehouseStockManager;


class UpdateWarehouseStock extends Command
{
    private ManagerIntegration $managerIntegration;
    private WarehouseStockManager $warehouseStockManager;

    public function __construct(
        ManagerIntegration    $managerIntegration,
        WarehouseStockManager $warehouseStockManager
    )
    {
        $this->managerIntegration = $managerIntegration;
        parent::__construct();
        $this->warehouseStockManager = $warehouseStockManager;
    }

    protected function configure()
    {
        $this->setName('adwise:warehouse:update')
            ->setDescription('Update warehouse stock');
    }

    /**
     * @throws \Exception
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $warehouseStockData = $this->managerIntegration->getWarehouseStocks();
        $result = $this->warehouseStockManager->updateStockData($warehouseStockData);
        $output->writeln("Terminado");
        return 1;
    }
}
