define(['jquery'], function ($) {
    'use strict';

    var locationPageWidgetMixin = {
        initializeMap: function () {
            var self = this,
                mapOptions = {
                    zoom: 20,
                    center: self.options.locationData,
                    mapTypeId: google.maps.MapTypeId.ROADMAP
            },
                map = new google.maps.Map($(this.mapSelector)[0], mapOptions),
                locationMarker = new google.maps.Marker({
                    position: new google.maps.LatLng(self.options.locationData.lat, self.options.locationData.lng),
                    map: map,
                    icon: self.options.locationData.marker_url
                });

                self.directionsDisplay.setMap(map);
        }
    };

    return function (targetWidget) {
        $.widget('mage.amLocationPage', targetWidget, locationPageWidgetMixin);

        return $.mage.amLocationPage;
    };
});
